package org.jboss.security;

package .tmp;

import java.security.Principal;
import java.security.acl.Group;
import java.util.Enumeration;
import java.util.LinkedList;
import org.jboss.security.SimplePrincipal;

public class NestablePrincipal extends SimplePrincipal implements Group {
  private LinkedList principalStack;
  
  public NestablePrincipal(String name) {
    super(name);
    this.principalStack = new LinkedList();
  }
  
  public Enumeration members() {
    return (Enumeration)new IndexEnumeration(this);
  }
  
  public boolean removeMember(Principal user) {
    return this.principalStack.remove(user);
  }
  
  public boolean addMember(Principal user) {
    this.principalStack.addFirst(user);
    return true;
  }
  
  public boolean isMember(Principal member) {
    if (this.principalStack.size() == 0)
      return false; 
    Object activePrincipal = this.principalStack.getFirst();
    return member.equals(activePrincipal);
  }
}
